#include <Wire.h>
#include <LiquidCrystal_I2C.h>
#include "pitches.h"

#include "DHT.h"
#define DHTPIN 2     //digital pin sensor
#define ENABLE 5
#define DIRA 3
#define DIRB 4

#define DHTTYPE DHT22

LiquidCrystal_I2C lcd(0x27,20,4);

DHT dht(DHTPIN, DHTTYPE);

RTC_DS3231 rtc;

int temp = 30;
int heat = 20;
int pMin = 9;
int check = 0;
int pMax = 1019;

int tempo = 85;
int buzzer = 11;


int wholenote = (60000 * 4) / tempo;

int divider = 0, noteDuration = 0;

int melody[] = {
  NOTE_G4,8, NOTE_C4,8, NOTE_DS4,16, NOTE_F4,16, NOTE_G4,8, NOTE_C4,8, NOTE_DS4,16, NOTE_F4,16, //1
  
};
int notes = sizeof(melody) / sizeof(melody[0]) / 2;


void setup() {
  
  lcd.init();
  lcd.clear();         
  lcd.backlight();
  
  dht.begin();

  Serial.begin(9600);
  delay(3000);

  pinMode(ENABLE,OUTPUT);
  pinMode(DIRA,OUTPUT);
  pinMode(DIRB,OUTPUT);
  pinMode(9, OUTPUT);
  pinMode(10, OUTPUT);

}

void loop() {
  delay(100);
  //lcd.clear(); 
  float h = dht.readHumidity();
  float t = dht.readTemperature();
  if (isnan(h) || isnan(t)) {
   lcd.print("NO CONNECTION");
    return;
  }

  DateTime now = rtc.now();
  lcd.setCursor(0,0);
  lcd.print(now.hour(), DEC);
  lcd.print(':');
  lcd.print(now.minute(), DEC);
  lcd.print(':');
  lcd.print(now.second(), DEC);
  lcd.setCursor(12,0);
  lcd.print(now.day(), DEC);
  lcd.print('/');
  lcd.print(now.month(), DEC);
  lcd.print('/');
  lcd.print(now.year(), DEC);
  
 
  lcd.setCursor(1, 1);
  lcd.print("Humidity: ");
  lcd.setCursor(11, 1);
  lcd.print(h);
  lcd.print(" %");

  lcd.setCursor(1, 2);
  lcd.print("Temp: ");
  lcd.setCursor(11, 2);
  lcd.print(t);
  lcd.print(" C");

  temp = analogRead(A0);
  heat = analogRead(A1);
  Serial.println(heat);
  temp = map(temp, pMin, pMax, 17, 40);
  heat = map(heat, pMin, pMax, 17, 40);

  if (temp > t) {
    digitalWrite(9, LOW);  
    digitalWrite(10, HIGH);
    if (check != 1) {
      digitalWrite(ENABLE,HIGH);
      digitalWrite(DIRA,HIGH);
      digitalWrite(DIRB,LOW);
      for (int thisNote = 0; thisNote < 12; thisNote = thisNote + 2) {
        divider = melody[thisNote + 1];
        if (divider > 0) {
      
          noteDuration = (wholenote) / divider;
        } 

        tone(buzzer, melody[thisNote], noteDuration * 0.9);

        delay(noteDuration);

        noTone(buzzer);
      }
      
      check = 1;
    }
    
    
  } else if (heat < t) {
    digitalWrite(10, LOW);
    digitalWrite(9, HIGH);
    if (check != 2) {
      digitalWrite(ENABLE,HIGH); //enable on
      digitalWrite(DIRA,LOW); //one way
      digitalWrite(DIRB,HIGH);
      for (int thisNote = 0; thisNote < 12; thisNote = thisNote + 2) {
        divider = melody[thisNote + 1];
        if (divider > 0) {
      
          noteDuration = (wholenote) / divider;
        } 

        tone(buzzer, melody[thisNote], noteDuration * 0.9);

        delay(noteDuration);

        noTone(buzzer);
      }
      
      check = 2;
    }
    
    
  } else {
    if (check) {
      digitalWrite(ENABLE,LOW); //enablE
      check = 0;
    }
    digitalWrite(10, LOW);
    digitalWrite(9, LOW);
  }

  lcd.setCursor(0, 3);
  lcd.print("Heat: ");
  //lcd.setCursor(11, 2);
  lcd.print(temp);

  lcd.setCursor(12, 3);
  lcd.print("Cool: ");
  //lcd.setCursor(11, 2);
  lcd.print(heat);

  

}
